// (C) Chistyakov T. S. 2008

{$apptype console}
{$O-}

uses
  Classes, Math;

var
  n: integer;
  x, y: array of extended;
  minCos: extended;
  minA, minB, minC: integer;
  points: TList;
  center, origin: integer;

function test(AC, AI, AJ: integer): integer;
var
  vp: extended;
begin
  vp := (x[AI] - x[AC]) * (y[AJ] - y[AC]) - (x[AJ] - x[AC]) * (y[AI] - y[AC]);
  if (vp < 0) then
    Result := -1
  else if (vp > 0) then
    Result := 1
  else
    Result := 0;
end;


function cmpPoints(Item1, Item2: pointer): integer;
var
  i1: integer absolute Item1;
  i2: integer absolute Item2;
  s1, s2: integer;
begin
  s1 := test(center, origin, i1);
  s2 := test(center, origin, i2);
  if (s1 = 0) and (s2 = 0) then
    Result := 0
  else if (s1 = 0) then
    Result := -1
  else if (s2 = 0) then
    Result := 1
  else if (s1 <> s2) then
    Result := s2 - s1
  else
    Result := test(center, i2, i1);
end;


procedure checkCos(AI, AJ: integer);
var
  sp, c: extended;
begin
  sp :=
    (x[AI] - x[Center]) * (x[AJ] - x[Center]) +
    (y[AI] - y[Center]) * (y[AJ] - y[Center]);
  c :=
    sp / (
      Norm([x[AI] - x[Center], y[AI] - y[Center]]) *
      Norm([x[AJ] - x[Center], y[AJ] - y[Center]])
    );
  if c < minCos then begin
    minCos := c;
    minA := AI;
    minB := Center;
    minC := AJ;
  end;
end;


procedure findMinForCenter;
var
  i, j, di: integer;
  base, s, l, r, t: integer;
begin
  di := 0;
  for i := 0 to n - 1 do
    if i <> Center then
      points[i - di] := Ptr(i)
    else
      Inc(di);

  if Center = 0 then
    origin := 1
  else
    origin := 0;
  points.Sort(cmpPoints);

  base := 0;
  for i := 0 to n - 1 do begin
    if i = Center then
      Continue;
    l := 1;
    r := n - 2;
    while l < r do begin
      t := (l + r) div 2;
      s :=
        test(
          Center, integer(points[base]),
          integer(points[(base + t) mod (n - 1)]));
      if s < 0 then
        r := t - 1
      else if s > 0 then
        l := t + 1
      else // must never happen
        Assert(false);
    end;
    for j := Max(0, r - 1) to Min(n - 2, l + 1) do
      checkCos(integer(points[base]), integer(points[(base + j) mod (n - 1)]));
    Inc(base);
  end;
end;


var
  fi, fo: textfile;
  i: integer;
begin
  assignfile(fi, 'input.txt'); reset(fi);
  assignfile(fo, 'output.txt'); rewrite(fo);

  read(fi, n);
  setlength(x, n);
  setlength(y, n);
  for i := 0 to n - 1 do
    read(fi, x[i], y[i]);

  minCos := 1;
  points := TList.Create;
  try
    points.Capacity := n - 1;
    for i := 0 to n - 2 do
      points.Add(nil);
    for i := 0 to n - 1 do begin
      center := i;
      findMinForCenter;
    end;
  finally
    points.Free;
  end;
  write(fo, minA + 1, ' ', minB + 1, ' ', minC + 1);

  closefile(fi);
  closefile(fo);
end.