#include <iostream>
#include <cmath>
#include <algorithm>

using namespace std;

const int maxn = 5010;
const double eps = 1e-12;

struct Point
{
   int num;
   double alfa;

   Point(int _num, double _alfa): num(_num), alfa(_alfa) {}
   Point() {}
};

double x[maxn], y[maxn];
Point a[maxn];
double best;
int bestA, bestB, bestC;

bool lss(const Point &a, const Point &b)
{
   return a.alfa < b.alfa;
}

double dist(int i, int j)
{
   return sqrt((x[i]-x[j])*(x[i]-x[j]) + (y[i]-y[j])*(y[i]-y[j]));
}

void tr(int A, int B, int C)
{
   double a = dist(B, C);
   double b = dist(A, C);
   double c = dist(A, B);
   double alfa = (a*a + c*c - b*b) / (2*a*c);
   if (alfa < best) {
      best = alfa; bestA = A; bestB = B; bestC = C;
   }
}

int main()
{
   freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);

   int i, j, k, n;
   cin >> n;
   for (i = 0; i < n; i++)
      cin >> x[i] >> y[i];

   best = 1.1;
   for (i = 0; i < n; i++) {
      k = 0;
      for (j = 0; j < n; j++) if (i != j) {
         a[k++] = Point(j, atan2(y[j]-y[i], x[j]-x[i]));
      }
      sort(a+0, a+k, lss);
      a[k] = a[0];
      for (j = 1; j <= k; j++) {
         if (abs(a[j].alfa - a[j-1].alfa) < eps) return 1;
         tr(i, a[j].num, a[j-1].num);
         tr(i, a[j-1].num, a[j].num);
      }
   }

   cout << bestA+1 << " " << bestB+1 << " " << bestC+1;

   fclose(stdin); fclose(stdout);
   return 0;
}
