#include <stdio.h>
#include <iostream>
#include <algorithm>
#include <vector>
#include <math.h>


using namespace std;


class Point {
  friend class Angle;

private:
  double x, y, angle;
  int num;

public:
  Point(double _x, double _y, int _num = rand()): x(_x), y(_y), num(_num) {
    angle = atan2(y, x);
  }

  static Point read(int _num = rand()) {
    int x, y;
    scanf("%d%d", &x, &y);
    return Point(x, y, _num);
  }

  Point operator - (const Point& p) const {
    return Point(x - p.x, y - p.y, num);
  }

  double length() const {
    return sqrt(x*x + y*y);
  }

  double length2() const {
    return x*x + y*y;
  }

  bool operator < (const Point& a) const {
    return angle < a.angle;
  }
};


class Angle {
private:
  Point a, b, c;

public:
  Angle(const Point& _a, const Point& _b, const Point& _c): a(_a), b(0, 0, _b.num), c(_c) {
    //
  }

  void print() const {
    printf("%d %d %d", a.num, b.num, c.num);
  }

  double getCos() const {
    Point ba = a - b;
    Point bc = c - b;
    Point ac = c - a;
    return (ba.length2() + bc.length2() - ac.length2()) / (2 * ba.length() * bc.length());
  }

  bool tryNew(const Angle& newAngle) {
    if (newAngle.getCos() < getCos()) {
      a = newAngle.a;
      b = newAngle.b;
      c = newAngle.c;
      return true;
    } else {
      return false;
    }
  }
};


int i, n;
vector<Point> p, pt;


int main() {
  srand(28102010);
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);

  scanf("%d", &n);
  p.reserve(n);
  for (int i = 0; i < n; i++) {
    p.push_back(Point::read(i+1));
  }
  Angle ans(p[0]-p[1], p[1], p[2]-p[1]);

  for (vector<Point>::const_iterator it = p.begin(); it != p.end(); it++) {
    pt.clear(); pt.reserve(n);
    for (vector<Point>::const_iterator itpt = p.begin(); itpt != p.end(); itpt++) {
      if (itpt != it) {
        pt.push_back(*itpt - *it);
      }
    }
    sort(pt.begin(), pt.end());
    vector<Point>::const_iterator ita = pt.begin();
    vector<Point>::const_iterator itc = ++pt.begin();
    Angle curr(*ita, *it, *itc);
    do {
      curr.tryNew(Angle(*ita, *it, *itc));
      while (++itc != pt.end()) {
        if (!curr.tryNew(Angle(*ita, *it, *itc))) {
          itc--;
          break;
        }
      }
      ans.tryNew(curr);
      ita++;
    } while (ita != pt.end() && itc != pt.end());
  }

  ans.print();

  fclose(stdin);
  fclose(stdout);
}
